# Class BimPointBase`Abstract`

Base class for tracked 3D points. Point coordinates can be applied in both local and world space.

#### Hierarchy (View Summary)

- BimPointBase
  - DynamicPolygonPoint
  - Html2CanvasPoint

#### Implements

- TrackCoordinate3D

##### Index

### Constructors

constructor

### Properties

_localX
_localY
_localZ
_recalculateLocalCoords
_recalculateWorldCoords
_worldX
_worldY
_worldZ

### Accessors

localX
localY
localZ
x
y
z

### Methods

recalculateOrGetLocalCoords
recalculateOrGetWorldCoords
setLocals

## Constructors

### constructor

- new BimPointBase(): BimPointBase

  #### Returns BimPointBase

## Properties

### `Protected`_localX

_localX: number = 0

### `Protected`_localY

_localY: number = 0

### `Protected`_localZ

_localZ: number = 0

### `Protected`_recalculateLocalCoords

_recalculateLocalCoords: boolean = false

### `Protected`_recalculateWorldCoords

_recalculateWorldCoords: boolean = false

### `Protected`_worldX

_worldX: number

### `Protected`_worldY

_worldY: number

### `Protected`_worldZ

_worldZ: number

## Accessors

### localX

- get localX(): number

  X coordinate of point in local space.

  #### Returns number

### localY

- get localY(): number

  Y coordinate of point in local space.

  #### Returns number

### localZ

- get localZ(): number

  Z coordinate of point in local space.

  #### Returns number

### x

- get x(): number

  X coordinate of point in world space.

  #### Returns number

  Implementation of TrackCoordinate3D.x

- set x(val: number): void

  Set the X coordinate of point in world space.

  #### Parameters

  - val: number

  #### Returns void

  Implementation of TrackCoordinate3D.x

### y

- get y(): number

  Y coordinate of point in world space.

  #### Returns number

  Implementation of TrackCoordinate3D.y

- set y(val: number): void

  Set the Y coordinate of point in world space.

  #### Parameters

  - val: number

  #### Returns void

  Implementation of TrackCoordinate3D.y

### z

- get z(): number

  Z coordinate of point in world space.

  #### Returns number

  Implementation of TrackCoordinate3D.z

- set z(val: number): void

  Set the Z coordinate of point in world space.

  #### Parameters

  - val: number

  #### Returns void

  Implementation of TrackCoordinate3D.z

## Methods

### `Protected` `Abstract` recalculateOrGetLocalCoords

- recalculateOrGetLocalCoords(force?: boolean): Vertex3

  #### Parameters

  - `Optional` force: boolean

  #### Returns Vertex3

### `Protected` `Abstract` recalculateOrGetWorldCoords

- recalculateOrGetWorldCoords(force?: boolean): Vertex3

  #### Parameters

  - `Optional` force: boolean

  #### Returns Vertex3

### setLocals

- setLocals(x: number, y: number, z: number): void

  Set coordinates in local space.

  #### Parameters

  - x: number

    X coordinate in local space.

  - y: number

    Y coordinate in local space.

  - z: number

    Z coordinate in local space.

  #### Returns void